#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void dfs(int u,
		 vector<int>& sortiran,
		 vector<bool>& posecen,
		 vector< vector<int> >& graf) {
	posecen[u] = true;
	for(int v : graf[u])
		if(!posecen[v])
			dfs(v, sortiran, posecen, graf);
	sortiran.push_back(u);
}

vector<int> topsort(vector< vector<int> >& graf) {
	int n = graf.size();
	vector<int> s;
	vector<bool> posecen(n);
	for(int u = 0; u < n; u++)
		if(!posecen[u])
			dfs(u, s, posecen, graf);
	reverse(s.begin(), s.end());
	return s;
}

int main() {
	int n, m;
	cin >> n >> m;

	vector< vector<int> > graf(n);
	for(int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		graf[u].push_back(v);
	}

	vector<int> s = topsort(graf);
	for(int u : s)
		cout << u << ' ';
	cout << '\n';

	return 0;
}
