#include <iostream>
#include <vector>
#include <tuple>

using namespace std;

vector<int> topsort(vector< vector<int> >& graf) {
	int n = graf.size();
	vector<int> indeg(n);
	for(int u = 0; u < n; u++)
		for(int v : graf[u])
			indeg[v]++;

	vector<int> q;
	for(int u = 0; u < n; u++)
		if(indeg[u] == 0)
			q.push_back(u);

	for(int i = 0; i < q.size(); i++) {
		int u = q[i];
		for(int v : graf[u]) {
			indeg[v]--;
			if(indeg[v] == 0)
				q.push_back(v);
		}
	}

	return q;
}

int main() {
	int n, m;
	cin >> n >> m;

	vector< vector<int> > graf(n);
	vector< pair<int, int> > neusmerene;
	for(int i = 0; i < m; i++) {
		// Grana (x, y) se unosi u obliku
		// "u x y" za usmerene grane
		// "n x y" za neusmerene grane
		string s;
		cin >> s;
		int u, v;
		cin >> u >> v;
		if(s == "u")
			graf[u].push_back(v);
		else
			neusmerene.push_back({u, v});
	}

	vector<int> s = topsort(graf);
	
	// pos[v] - pozicija cvora v u topoloskom uredjenju
	vector<int> pos(n);
	for(int i = 0; i < n; i++)
		pos[s[i]] = i;

	// Za sve neusmerene grane (u, v) odredjujemo
	// usmerenje na osnovu redosleda cvorova u i v
	for(auto grana : neusmerene) {
		int u, v;
		tie(u, v) = grana;
		if(pos[u] > pos[v])
			swap(u, v);
		cout << u << ' ' << v << '\n';
	}

	return 0;
}
